﻿<!DOCTYPE html>
<html>

<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>TP1_fr</title>
  <link rel="stylesheet" href="https://stackedit.io/style.css" />
</head>

<body class="stackedit">
  <div class="stackedit__html"><h1 id="tp1---création-dun-programme-plus-complexe">TP1 :  Création d’un programme plus complexe</h1>
<p>Vous êtes normalement capable de coder un programme capable de réaliser une multiplication entre deux nombres avec l’aide des instructions élémentaires de l’ISA (Jeu d’instruction) LC-3</p>
<blockquote>
<p>Le livrable attendu pour ce TP est une archive zip contenant un document par balise “<strong>Livrable attendu</strong>” dans le TP<br>
Chaque livrable sera nommé selon la consigne de la balise<br>
Le TP peut être fait par binôme, MAIS chaque élève du binôme doit le rendre sur le moodle.<br>
Dans le cas d’un binôme, les deux noms doivent apparaitre sur chacune des copie. L’archive devra être intitulée nom1_nom2_tp1.zip<br>
Dans le cas contraire, l’archive devra être intitulée nom_tp1.zip</p>
</blockquote>
<h2 id="vérifions-cela-avec-un-premier-programme-simple-8-points">1. Vérifions cela avec un premier programme simple (8 Points)</h2>
<p>Pour vous remettre en jambe, je vous propose de réaliser un programme capable de multiplier deux valeurs en mémoire entre elle, et de stocker le résultat en mémoire. Vous utiliserez le template suivant comme base de votre programme</p>
<pre><code>.ORIG x3000

; Votre code après ce commentaire

VALEUR1 .FILL #10 ; Première valeur
VALEUR2 .FILL #5 ; Deuxième valeur
RESULTAT .FILL #0 ; Espace mémoire pour le résultat

.END
</code></pre>
<blockquote>
<p>Le caractère '; ’ permet d’insérer des commentaires dans l’assembleur LC-3</p>
</blockquote>
<p><em>Exercice :</em> Votre mission, si vous l’acceptez, est donc de multiplier les valeurs en mémoire indiquées par les labels <code>VALEUR1</code> et <code>VALEUR2</code>, puis de stocker le résultat dans la case mémoire labélisée <code>RESULTAT</code>.</p>
<blockquote>
<p><strong>Livrable attendu</strong> : Un code en assembleur LC-3 commenté et fonctionnel dans le simulateur <a href="https://wchargin.com/lc3web/">LC-3 Simulator (wchargin.com)</a><br>
Le code doit être commenté (sinon pénalité)<br>
Le livrable sera nommé ex1_tp1_nom1_nom2.txt</p>
</blockquote>
<h2 id="un-peu-plus-complexe-maintenant">2. Un peu plus complexe maintenant</h2>
<p>Nous souhaitons réaliser un programme capable de compter le nombre d’apparition d’un caractère dans une chaine de caractère. Pour cela nous allons découper le raisonnement en plusieurs étapes</p>
<h3 id="a.--les-barrières-de-la-langue-2-points">a.  Les barrières de la langue (2 Points)</h3>
<p>Dans un premier temps, je vais vous demander de compléter le programme suivant écrit en C.<br>
Ce programme doit être capable de compter le nombre d’occurrence du caractère <code>g_c_token</code> dans la chaine de caractère <code>g_tc_phrase</code> de longueur  <code>g_i_longueurPhrase</code></p>
<pre class=" language-c"><code class="prism  language-c"><span class="token keyword">const</span> <span class="token keyword">char</span> g_tc_phrase<span class="token punctuation">[</span><span class="token number">124</span><span class="token punctuation">]</span> <span class="token operator">=</span> <span class="token string">"Lorem ipsum dolor sit amet, "</span> \
						   <span class="token string">"consectetur adipiscing elit, "</span> \
						   <span class="token string">"sed do eiusmod tempor incididunt "</span> \
						   <span class="token string">"ut labore et dolore magna aliqua."</span><span class="token punctuation">;</span>
<span class="token keyword">const</span> <span class="token keyword">char</span> g_c_token <span class="token operator">=</span> <span class="token string">"r"</span><span class="token punctuation">;</span>
<span class="token keyword">const</span> <span class="token keyword">int</span> g_i_longueurPhrase <span class="token operator">=</span> <span class="token number">123</span><span class="token punctuation">;</span>
<span class="token keyword">int</span> g_i_nombreOccurrence <span class="token operator">=</span> <span class="token number">0</span><span class="token punctuation">;</span>

<span class="token keyword">int</span> <span class="token function">main</span><span class="token punctuation">(</span><span class="token keyword">int</span> argc<span class="token punctuation">,</span> <span class="token keyword">char</span> argv<span class="token punctuation">[</span><span class="token punctuation">]</span><span class="token punctuation">)</span><span class="token punctuation">{</span>
<span class="token comment">// Votre code après ce commentaire</span>
<span class="token punctuation">}</span>
</code></pre>
<p><em>Exercice :</em> Vous devez compléter le programme dans la main sans faire de fonction supplémentaire</p>
<blockquote>
<p><strong>Livrable attendu</strong> : Le code source C complété<br>
Le livrable sera nommé ex2_tp1_nom1_nom2.txt</p>
</blockquote>
<p>S’accrocher à un langage qu’on connait permet de raisonner rapidement. Cependant, certains concepts sont propre à certains langages et orientent donc forcément la façon avec laquelle nous cherchons à résoudre le problème. (Par exemple : Pas de classe et de mutation en C ; Pas de pointeur en python)</p>
<p>De plus, ces langages utilisent des niveaux d’abstractions qui leur sont propres.</p>
<h3 id="b.-représentation-universelle-2-points">b. Représentation universelle (2 Points)</h3>
<p>Il est important de savoir représenter le fonctionnement d’un programme sans langage particulier. On peut pour cela utiliser une représentation en diagramme de flux.</p>
<h4 id="exemple-pour-le-premier-programme-">Exemple pour le premier programme :</h4>
<pre class=" language-mermaid"><svg id="mermaid-svg-QGOhNHrMcHl7qa4K" width="100%" xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" height="589.4713134765625" style="max-width: 304.6781311035156px;" viewBox="0 -0.0000019073486328125 304.6781311035156 589.4713134765625"><style>#mermaid-svg-QGOhNHrMcHl7qa4K{font-family:"trebuchet ms",verdana,arial,sans-serif;font-size:16px;fill:#000000;}#mermaid-svg-QGOhNHrMcHl7qa4K .error-icon{fill:#552222;}#mermaid-svg-QGOhNHrMcHl7qa4K .error-text{fill:#552222;stroke:#552222;}#mermaid-svg-QGOhNHrMcHl7qa4K .edge-thickness-normal{stroke-width:2px;}#mermaid-svg-QGOhNHrMcHl7qa4K .edge-thickness-thick{stroke-width:3.5px;}#mermaid-svg-QGOhNHrMcHl7qa4K .edge-pattern-solid{stroke-dasharray:0;}#mermaid-svg-QGOhNHrMcHl7qa4K .edge-pattern-dashed{stroke-dasharray:3;}#mermaid-svg-QGOhNHrMcHl7qa4K .edge-pattern-dotted{stroke-dasharray:2;}#mermaid-svg-QGOhNHrMcHl7qa4K .marker{fill:#666;stroke:#666;}#mermaid-svg-QGOhNHrMcHl7qa4K .marker.cross{stroke:#666;}#mermaid-svg-QGOhNHrMcHl7qa4K svg{font-family:"trebuchet ms",verdana,arial,sans-serif;font-size:16px;}#mermaid-svg-QGOhNHrMcHl7qa4K .label{font-family:"trebuchet ms",verdana,arial,sans-serif;color:#000000;}#mermaid-svg-QGOhNHrMcHl7qa4K .cluster-label text{fill:#333;}#mermaid-svg-QGOhNHrMcHl7qa4K .cluster-label span{color:#333;}#mermaid-svg-QGOhNHrMcHl7qa4K .label text,#mermaid-svg-QGOhNHrMcHl7qa4K span{fill:#000000;color:#000000;}#mermaid-svg-QGOhNHrMcHl7qa4K .node rect,#mermaid-svg-QGOhNHrMcHl7qa4K .node circle,#mermaid-svg-QGOhNHrMcHl7qa4K .node ellipse,#mermaid-svg-QGOhNHrMcHl7qa4K .node polygon,#mermaid-svg-QGOhNHrMcHl7qa4K .node path{fill:#eee;stroke:#999;stroke-width:1px;}#mermaid-svg-QGOhNHrMcHl7qa4K .node .label{text-align:center;}#mermaid-svg-QGOhNHrMcHl7qa4K .node.clickable{cursor:pointer;}#mermaid-svg-QGOhNHrMcHl7qa4K .arrowheadPath{fill:#333333;}#mermaid-svg-QGOhNHrMcHl7qa4K .edgePath .path{stroke:#666;stroke-width:1.5px;}#mermaid-svg-QGOhNHrMcHl7qa4K .flowchart-link{stroke:#666;fill:none;}#mermaid-svg-QGOhNHrMcHl7qa4K .edgeLabel{background-color:white;text-align:center;}#mermaid-svg-QGOhNHrMcHl7qa4K .edgeLabel rect{opacity:0.5;background-color:white;fill:white;}#mermaid-svg-QGOhNHrMcHl7qa4K .cluster rect{fill:hsl(210,66.6666666667%,95%);stroke:#26a;stroke-width:1px;}#mermaid-svg-QGOhNHrMcHl7qa4K .cluster text{fill:#333;}#mermaid-svg-QGOhNHrMcHl7qa4K .cluster span{color:#333;}#mermaid-svg-QGOhNHrMcHl7qa4K div.mermaidTooltip{position:absolute;text-align:center;max-width:200px;padding:2px;font-family:"trebuchet ms",verdana,arial,sans-serif;font-size:12px;background:hsl(-160,0%,93.3333333333%);border:1px solid #26a;border-radius:2px;pointer-events:none;z-index:100;}#mermaid-svg-QGOhNHrMcHl7qa4K:root{--mermaid-font-family:"trebuchet ms",verdana,arial,sans-serif;}#mermaid-svg-QGOhNHrMcHl7qa4K flowchart{fill:apa;}</style><g><g class="output"><g class="clusters"></g><g class="edgePaths"><g class="edgePath LS-start LE-step1" id="L-start-step1" style="opacity: 1;"><path class="path" d="M173.04062938690186,61.79999923706055L173.04062938690186,86.79999923706055L173.04062938690186,111.79999923706055" marker-end="url(https://stackedit.io/app#arrowhead11)" style="fill:none"></path><defs><marker id="arrowhead11" viewBox="0 0 10 10" refX="9" refY="5" markerUnits="strokeWidth" markerWidth="8" markerHeight="6" orient="auto"><path d="M 0 0 L 10 5 L 0 10 z" class="arrowheadPath" style="stroke-width: 1; stroke-dasharray: 1, 0;"></path></marker></defs></g><g class="edgePath LS-step1 LE-step2" id="L-step1-step2" style="opacity: 1;"><path class="path" d="M138.20851097335103,158.51250076293945L100.92500305175781,183.51250076293945L100.92500305175781,208.51250076293945" marker-end="url(https://stackedit.io/app#arrowhead12)" style="fill:none"></path><defs><marker id="arrowhead12" viewBox="0 0 10 10" refX="9" refY="5" markerUnits="strokeWidth" markerWidth="8" markerHeight="6" orient="auto"><path d="M 0 0 L 10 5 L 0 10 z" class="arrowheadPath" style="stroke-width: 1; stroke-dasharray: 1, 0;"></path></marker></defs></g><g class="edgePath LS-step2 LE-loop" id="L-step2-loop" style="opacity: 1;"><path class="path" d="M100.92500305175781,255.22500228881836L100.92500305175781,280.22500228881836L142.20973396090818,337.05589685650534" marker-end="url(https://stackedit.io/app#arrowhead13)" style="fill:none"></path><defs><marker id="arrowhead13" viewBox="0 0 10 10" refX="9" refY="5" markerUnits="strokeWidth" markerWidth="8" markerHeight="6" orient="auto"><path d="M 0 0 L 10 5 L 0 10 z" class="arrowheadPath" style="stroke-width: 1; stroke-dasharray: 1, 0;"></path></marker></defs></g><g class="edgePath LS-loop LE-step1" id="L-loop-step1" style="opacity: 1;"><path class="path" d="M204.8715240919857,337.055897852209L245.1562557220459,280.22500228881836L245.1562557220459,231.8687515258789L245.1562557220459,183.51250076293945L207.8727478004527,158.51250076293945" marker-end="url(https://stackedit.io/app#arrowhead14)" style="fill:none"></path><defs><marker id="arrowhead14" viewBox="0 0 10 10" refX="9" refY="5" markerUnits="strokeWidth" markerWidth="8" markerHeight="6" orient="auto"><path d="M 0 0 L 10 5 L 0 10 z" class="arrowheadPath" style="stroke-width: 1; stroke-dasharray: 1, 0;"></path></marker></defs></g><g class="edgePath LS-loop LE-stop" id="L-loop-stop" style="opacity: 1;"><path class="path" d="M173.5406293869018,454.93375520706195L173.04062938690186,492.79000759124756L173.04062938690186,531.1462574005127" marker-end="url(https://stackedit.io/app#arrowhead15)" style="fill:none"></path><defs><marker id="arrowhead15" viewBox="0 0 10 10" refX="9" refY="5" markerUnits="strokeWidth" markerWidth="8" markerHeight="6" orient="auto"><path d="M 0 0 L 10 5 L 0 10 z" class="arrowheadPath" style="stroke-width: 1; stroke-dasharray: 1, 0;"></path></marker></defs></g></g><g class="edgeLabels"><g class="edgeLabel" transform="" style="opacity: 1;"><g transform="translate(0,0)" class="label"><rect rx="0" ry="0" width="0" height="0"></rect><foreignObject width="0" height="0"><div xmlns="http://www.w3.org/1999/xhtml" style="display: inline-block; white-space: nowrap;"><span id="L-L-start-step1" class="edgeLabel L-LS-start' L-LE-step1"></span></div></foreignObject></g></g><g class="edgeLabel" transform="" style="opacity: 1;"><g transform="translate(0,0)" class="label"><rect rx="0" ry="0" width="0" height="0"></rect><foreignObject width="0" height="0"><div xmlns="http://www.w3.org/1999/xhtml" style="display: inline-block; white-space: nowrap;"><span id="L-L-step1-step2" class="edgeLabel L-LS-step1' L-LE-step2"></span></div></foreignObject></g></g><g class="edgeLabel" transform="" style="opacity: 1;"><g transform="translate(0,0)" class="label"><rect rx="0" ry="0" width="0" height="0"></rect><foreignObject width="0" height="0"><div xmlns="http://www.w3.org/1999/xhtml" style="display: inline-block; white-space: nowrap;"><span id="L-L-step2-loop" class="edgeLabel L-LS-step2' L-LE-loop"></span></div></foreignObject></g></g><g class="edgeLabel" transform="translate(245.1562557220459,231.8687515258789)" style="opacity: 1;"><g transform="translate(-16.306249618530273,-13.356249809265137)" class="label"><rect rx="0" ry="0" width="32.61249923706055" height="26.712499618530273"></rect><foreignObject width="32.61249923706055" height="26.712499618530273"><div xmlns="http://www.w3.org/1999/xhtml" style="display: inline-block; white-space: nowrap;"><span id="L-L-loop-step1" class="edgeLabel L-LS-loop' L-LE-step1">VRAI</span></div></foreignObject></g></g><g class="edgeLabel" transform="translate(173.04062938690186,492.79000759124756)" style="opacity: 1;"><g transform="translate(-17.71406364440918,-13.356249809265137)" class="label"><rect rx="0" ry="0" width="35.42812728881836" height="26.712499618530273"></rect><foreignObject width="35.42812728881836" height="26.712499618530273"><div xmlns="http://www.w3.org/1999/xhtml" style="display: inline-block; white-space: nowrap;"><span id="L-L-loop-stop" class="edgeLabel L-LS-loop' L-LE-stop">FAUX</span></div></foreignObject></g></g></g><g class="nodes"><g class="node default" id="flowchart-start-75" transform="translate(173.04062938690186,34.89999961853027)" style="opacity: 1;"><circle x="-26.899999618530273" y="-23.356249809265137" r="26.899999618530273" class="label-container"></circle><g class="label" transform="translate(0,0)"><g transform="translate(-16.899999618530273,-13.356249809265137)"><foreignObject width="33.79999923706055" height="26.712499618530273"><div xmlns="http://www.w3.org/1999/xhtml" style="display: inline-block; white-space: nowrap;">start</div></foreignObject></g></g></g><g class="node default" id="flowchart-stop-76" transform="translate(173.04062938690186,556.3087577819824)" style="opacity: 1;"><circle x="-25.162500381469727" y="-23.356249809265137" r="25.162500381469727" class="label-container"></circle><g class="label" transform="translate(0,0)"><g transform="translate(-15.162500381469727,-13.356249809265137)"><foreignObject width="30.325000762939453" height="26.712499618530273"><div xmlns="http://www.w3.org/1999/xhtml" style="display: inline-block; white-space: nowrap;">stop</div></foreignObject></g></g></g><g class="node default" id="flowchart-step1-77" transform="translate(173.04062938690186,135.15625)" style="opacity: 1;"><rect rx="0" ry="0" x="-123.63750457763672" y="-23.356249809265137" width="247.27500915527344" height="46.71249961853027" class="label-container"></rect><g class="label" transform="translate(0,0)"><g transform="translate(-113.63750457763672,-13.356249809265137)"><foreignObject width="227.27500915527344" height="26.712499618530273"><div xmlns="http://www.w3.org/1999/xhtml" style="display: inline-block; white-space: nowrap;">RESULTAT = RESULTAT +VALEUR1</div></foreignObject></g></g></g><g class="node default" id="flowchart-step2-78" transform="translate(100.92500305175781,231.8687515258789)" style="opacity: 1;"><rect rx="0" ry="0" x="-92.92500305175781" y="-23.356249809265137" width="185.85000610351562" height="46.71249961853027" class="label-container"></rect><g class="label" transform="translate(0,0)"><g transform="translate(-82.92500305175781,-13.356249809265137)"><foreignObject width="165.85000610351562" height="26.712499618530273"><div xmlns="http://www.w3.org/1999/xhtml" style="display: inline-block; white-space: nowrap;">VALEUR2 = VALEUR2 - 1</div></foreignObject></g></g></g><g class="node default" id="flowchart-loop-79" transform="translate(173.04062938690186,379.8293800354004)" style="opacity: 1;"><polygon points="74.60437688827516,0 149.2087537765503,-74.60437688827516 74.60437688827516,-149.2087537765503 0,-74.60437688827516" transform="translate(-74.60437688827516,74.60437688827516)" class="label-container"></polygon><g class="label" transform="translate(0,0)"><g transform="translate(-49.53750228881836,-13.356249809265137)"><foreignObject width="99.07500457763672" height="26.712499618530273"><div xmlns="http://www.w3.org/1999/xhtml" style="display: inline-block; white-space: nowrap;">VALEUR2 &gt; 0 ?</div></foreignObject></g></g></g></g></g></g></svg></pre>
<p><em>Exercice :</em> Avec l’outil de votre choix (si vous n’en avez pas, je peux vous conseiller <a href="https://app.diagrams.net/">test.drawio - diagrams.net</a>) vous devez réaliser le diagramme de flux d’un programme permettant de compter le nombre d’occurrences d’un caractère dans une chaine de caractère.</p>
<blockquote>
<p><strong>Livrable attendu</strong> : Le diagramme de flux précédemment décrit<br>
Le livrable sera nommé ex3_tp1_nom1_nom2.png</p>
</blockquote>
<h3 id="c.-traduction-en-asm-lc-3-4-points">c. Traduction en ASM LC-3 (4 Points)</h3>
<p>En vous appuyant sur le diagramme de flux que vous aurez réalisé, vous devez maintenant traduire votre algorithme en assembleur LC-3, en prenant donc en compte les contraintes de l’architecture LC-3 :</p>
<ul>
<li>Modèle (3, 0)</li>
<li>Peu de registres</li>
<li>Peu d’instructions disponibles</li>
<li>…</li>
</ul>
<p>Vous utiliserez le code ci-dessous comme base. Le caractère dont il faut compter l’occurrence est stocké à l’adresse mémoire labélisée <code>CHAR</code>, la chaine de caractère dans laquelle il faut compter les occurrences commence à l’adresse mémoire labélisée <code>LOREM</code>. La taille de cette chaine est stockée dans la case mémoire labélisée <code>LEN</code>. Il est attendu de stocker le résultat du nombre d’occurrence dans la case mémoire à l’adresse labélisée <code>CMPT</code>.</p>
<pre><code>.orig x3000

; Votre code après ce commentaire


CHAR .STRINGZ "r" ; caractère dont on souhaite compter le nombre d'itérations
PHRASE .STRINGZ "Lorem ipsum dolor sit amet, consectetur adipiscing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua." ; Chaine de caractère dans laquelle on souhaite compter les itérations
LONGUEUR .FILL #123 ; taille de la chaine de caractère
COMPTEUR .FILL #0 ; espace mémoire pour stocker le résultat

.END
</code></pre>
<blockquote>
<p><strong>Livrable attendu</strong> : Un code en assembleur LC-3 commenté et fonctionnel dans le simulateur <a href="https://wchargin.com/lc3web/">LC-3 Simulator (wchargin.com)</a><br>
Le code doit être commenté (sinon pénalité)<br>
Le livrable sera nommé ex4_tp1_nom1_nom2.txt</p>
</blockquote>
<h3 id="d.-sans-taille-4-points">d. Sans taille (4 Points)</h3>
<p>En plus de charger un tableau de caractère en mémoire, la directive STRINGZ charge  un caractère NULL à la fin du tableau de caractère. Pour vous en rendre compte, chargez le code suivant dans le simulateur, et constaté l’éspace entre la fin le dernier caractère <code>m</code> et la valeur <code>xDEAD</code> :</p>
<pre><code>.orig x3000

PHRASE .STRINGZ "Lorem" ; Chaine de caractère dans laquelle on souhaite compter les itérations
MARQUEUR .FILL xDEAD ; taille de la chaine de caractère

.END
</code></pre>
<p>En exploitant cette information, proposez une variante du programme précédent sans  utiliser la taille de la phrase.</p>
<pre><code>.orig x3000

; Votre code après ce commentaire


CHAR .STRINGZ "r" ; caractère dont on souhaite compter le nombre d'itérations
PHRASE .STRINGZ "Lorem ipsum dolor sit amet, consectetur adipiscing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua." ; Chaine de caractère dans laquelle on souhaite compter les itérations
COMPTEUR .FILL #0 ; espace mémoire pour stocker le résultat

.END
</code></pre>
<blockquote>
<p><strong>Livrable attendu</strong> : Un code en assembleur LC-3 commenté et fonctionnel dans le simulateur <a href="https://wchargin.com/lc3web/">LC-3 Simulator (wchargin.com)</a><br>
Le code doit être commenté (sinon pénalité)<br>
Le livrable sera nommé ex5_tp1_nom1_nom2.txt</p>
</blockquote>
<h4 id="bonus">bonus</h4>
<p>Je propose désormais de rajouter une contrainte supplémentaire. Nous verrons plus tard que certains registres génériques ne sont pas vraiment disponible pour stocker des variables de travail car utilisés pour d’autres tâches.</p>
<p>Cherchez à réaliser le programme précèdent en utilisant seulement les registres R0, R1, R2 et R4</p>
</div>
</body>

</html>
